microtime = require('microtime')
async = require('async')

Wordnet = require('../src/wordnet')
wordnet = new Wordnet()

testText = """
Emma Woodhouse, handsome, clever, and rich, with a comfortable home
and happy disposition, seemed to unite some of the best blessings of
existence; and had lived nearly twenty-one years in the world with very
little to distress or vex her.

She was the youngest of the two daughters of a most affectionate,
indulgent father; and had, in consequence of her sister's marriage, been
mistress of his house from a very early period. Her mother had died
too long ago for her to have more than an indistinct remembrance of
her caresses; and her place had been supplied by an excellent woman as
governess, who had fallen little short of a mother in affection.

Sixteen years had Miss Taylor been in Mr. Woodhouse's family, less as a
governess than a friend, very fond of both daughters, but particularly
of Emma. Between _them_ it was more the intimacy of sisters. Even before
Miss Taylor had ceased to hold the nominal office of governess, the
mildness of her temper had hardly allowed her to impose any restraint;
and the shadow of authority being now long passed away, they had been
living together as friend and friend very mutually attached, and Emma
doing just what she liked; highly esteeming Miss Taylor's judgment, but
directed chiefly by her own.

The real evils, indeed, of Emma's situation were the power of having
rather too much her own way, and a disposition to think a little too
well of herself; these were the disadvantages which threatened alloy to
her many enjoyments. The danger, however, was at present so unperceived,
that they did not by any means rank as misfortunes with her.

Sorrow came--a gentle sorrow--but not at all in the shape of any
disagreeable consciousness.--Miss Taylor married. It was Miss Taylor's
loss which first brought grief. It was on the wedding-day of this
beloved friend that Emma first sat in mournful thought of any
continuance. The wedding over, and the bride-people gone, her father and
herself were left to dine together, with no prospect of a third to cheer
a long evening. Her father composed himself to sleep after dinner, as
usual, and she had then only to sit and think of what she had lost.

The event had every promise of happiness for her friend. Mr. Weston
was a man of unexceptionable character, easy fortune, suitable age, and
pleasant manners; and there was some satisfaction in considering
with what self-denying, generous friendship she had always wished and
promoted the match; but it was a black morning's work for her. The want
of Miss Taylor would be felt every hour of every day. She recalled her
past kindness--the kindness, the affection of sixteen years--how she had
taught and how she had played with her from five years old--how she had
devoted all her powers to attach and amuse her in health--and how
nursed her through the various illnesses of childhood. A large debt of
gratitude was owing here; but the intercourse of the last seven
years, the equal footing and perfect unreserve which had soon followed
Isabella's marriage, on their being left to each other, was yet a
dearer, tenderer recollection. She had been a friend and companion such
as few possessed: intelligent, well-informed, useful, gentle, knowing
all the ways of the family, interested in all its concerns, and
peculiarly interested in herself, in every pleasure, every scheme of
hers--one to whom she could speak every thought as it arose, and who had
such an affection for her as could never find fault.

How was she to bear the change?--It was true that her friend was going
only half a mile from them; but Emma was aware that great must be the
difference between a Mrs. Weston, only half a mile from them, and a Miss
Taylor in the house; and with all her advantages, natural and domestic,
she was now in great danger of suffering from intellectual solitude. She
dearly loved her father, but he was no companion for her. He could not
meet her in conversation, rational or playful.

The evil of the actual disparity in their ages (and Mr. Woodhouse had
not married early) was much increased by his constitution and habits;
for having been a valetudinarian all his life, without activity of
mind or body, he was a much older man in ways than in years; and though
everywhere beloved for the friendliness of his heart and his amiable
temper, his talents could not have recommended him at any time.

Her sister, though comparatively but little removed by matrimony, being
settled in London, only sixteen miles off, was much beyond her daily
reach; and many a long October and November evening must be struggled
through at Hartfield, before Christmas brought the next visit from
Isabella and her husband, and their little children, to fill the house,
and give her pleasant society again.

Highbury, the large and populous village, almost amounting to a town,
to which Hartfield, in spite of its separate lawn, and shrubberies, and
name, did really belong, afforded her no equals. The Woodhouses
were first in consequence there. All looked up to them. She had many
acquaintance in the place, for her father was universally civil, but
not one among them who could be accepted in lieu of Miss Taylor for even
half a day. It was a melancholy change; and Emma could not but sigh over
it, and wish for impossible things, till her father awoke, and made it
necessary to be cheerful. His spirits required support. He was a nervous
man, easily depressed; fond of every body that he was used to, and
hating to part with them; hating change of every kind. Matrimony, as the
origin of change, was always disagreeable; and he was by no means yet
reconciled to his own daughter's marrying, nor could ever speak of her
but with compassion, though it had been entirely a match of affection,
when he was now obliged to part with Miss Taylor too; and from his
habits of gentle selfishness, and of being never able to suppose that
other people could feel differently from himself, he was very much
disposed to think Miss Taylor had done as sad a thing for herself as for
them, and would have been a great deal happier if she had spent all the
rest of her life at Hartfield. Emma smiled and chatted as cheerfully
as she could, to keep him from such thoughts; but when tea came, it was
impossible for him not to say exactly as he had said at dinner,

"Poor Miss Taylor!--I wish she were here again. What a pity it is that
Mr. Weston ever thought of her!"

"I cannot agree with you, papa; you know I cannot. Mr. Weston is such
a good-humoured, pleasant, excellent man, that he thoroughly deserves
a good wife;--and you would not have had Miss Taylor live with us for
ever, and bear all my odd humours, when she might have a house of her
own?"

"A house of her own!--But where is the advantage of a house of her own?
This is three times as large.--And you have never any odd humours, my
dear."

"How often we shall be going to see them, and they coming to see us!--We
shall be always meeting! _We_ must begin; we must go and pay wedding
visit very soon."

"My dear, how am I to get so far? Randalls is such a distance. I could
not walk half so far."

"No, papa, nobody thought of your walking. We must go in the carriage,
to be sure."

"The carriage! But James will not like to put the horses to for such a
little way;--and where are the poor horses to be while we are paying our
visit?"

"They are to be put into Mr. Weston's stable, papa. You know we have
settled all that already. We talked it all over with Mr. Weston last
night. And as for James, you may be very sure he will always like going
to Randalls, because of his daughter's being housemaid there. I only
doubt whether he will ever take us anywhere else. That was your doing,
papa. You got Hannah that good place. Nobody thought of Hannah till you
mentioned her--James is so obliged to you!"

"I am very glad I did think of her. It was very lucky, for I would not
have had poor James think himself slighted upon any account; and I am
sure she will make a very good servant: she is a civil, pretty-spoken
girl; I have a great opinion of her. Whenever I see her, she always
curtseys and asks me how I do, in a very pretty manner; and when you
have had her here to do needlework, I observe she always turns the lock
of the door the right way and never bangs it. I am sure she will be an
excellent servant; and it will be a great comfort to poor Miss Taylor
to have somebody about her that she is used to see. Whenever James goes
over to see his daughter, you know, she will be hearing of us. He will
be able to tell her how we all are."

Emma spared no exertions to maintain this happier flow of ideas, and
hoped, by the help of backgammon, to get her father tolerably
through the evening, and be attacked by no regrets but her own. The
backgammon-table was placed; but a visitor immediately afterwards walked
in and made it unnecessary.

Mr. Knightley, a sensible man about seven or eight-and-thirty, was not
only a very old and intimate friend of the family, but particularly
connected with it, as the elder brother of Isabella's husband. He lived
about a mile from Highbury, was a frequent visitor, and always welcome,
and at this time more welcome than usual, as coming directly from their
mutual connexions in London. He had returned to a late dinner, after
some days' absence, and now walked up to Hartfield to say that all were
well in Brunswick Square. It was a happy circumstance, and animated
Mr. Woodhouse for some time. Mr. Knightley had a cheerful manner, which
always did him good; and his many inquiries after "poor Isabella" and
her children were answered most satisfactorily. When this was over, Mr.
Woodhouse gratefully observed, "It is very kind of you, Mr. Knightley,
to come out at this late hour to call upon us. I am afraid you must have
had a shocking walk."

"Not at all, sir. It is a beautiful moonlight night; and so mild that I
must draw back from your great fire."

"But you must have found it very damp and dirty. I wish you may not
catch cold."

"Dirty, sir! Look at my shoes. Not a speck on them."

"Well! that is quite surprising, for we have had a vast deal of rain
here. It rained dreadfully hard for half an hour while we were at
breakfast. I wanted them to put off the wedding."

"By the bye--I have not wished you joy. Being pretty well aware of what
sort of joy you must both be feeling, I have been in no hurry with my
congratulations; but I hope it all went off tolerably well. How did you
all behave? Who cried most?"

"Ah! poor Miss Taylor! 'Tis a sad business."

"Poor Mr. and Miss Woodhouse, if you please; but I cannot possibly say
'poor Miss Taylor.' I have a great regard for you and Emma; but when it
comes to the question of dependence or independence!--At any rate, it
must be better to have only one to please than two."

"Especially when _one_ of those two is such a fanciful, troublesome
creature!" said Emma playfully. "That is what you have in your head, I
know--and what you would certainly say if my father were not by."

"I believe it is very true, my dear, indeed," said Mr. Woodhouse, with a
sigh. "I am afraid I am sometimes very fanciful and troublesome."

"My dearest papa! You do not think I could mean _you_, or suppose Mr.
Knightley to mean _you_. What a horrible idea! Oh no! I meant only
myself. Mr. Knightley loves to find fault with me, you know--in a
joke--it is all a joke. We always say what we like to one another."

Mr. Knightley, in fact, was one of the few people who could see faults
in Emma Woodhouse, and the only one who ever told her of them: and
though this was not particularly agreeable to Emma herself, she knew
it would be so much less so to her father, that she would not have him
really suspect such a circumstance as her not being thought perfect by
every body.

"Emma knows I never flatter her," said Mr. Knightley, "but I meant no
reflection on any body. Miss Taylor has been used to have two persons
to please; she will now have but one. The chances are that she must be a
gainer."

"Well," said Emma, willing to let it pass--"you want to hear about
the wedding; and I shall be happy to tell you, for we all behaved
charmingly. Every body was punctual, every body in their best looks: not
a tear, and hardly a long face to be seen. Oh no; we all felt that we
were going to be only half a mile apart, and were sure of meeting every
day."

"Dear Emma bears every thing so well," said her father. "But, Mr.
Knightley, she is really very sorry to lose poor Miss Taylor, and I am
sure she _will_ miss her more than she thinks for."

Emma turned away her head, divided between tears and smiles. "It
is impossible that Emma should not miss such a companion," said Mr.
Knightley. "We should not like her so well as we do, sir, if we could
suppose it; but she knows how much the marriage is to Miss Taylor's
advantage; she knows how very acceptable it must be, at Miss Taylor's
time of life, to be settled in a home of her own, and how important to
her to be secure of a comfortable provision, and therefore cannot allow
herself to feel so much pain as pleasure. Every friend of Miss Taylor
must be glad to have her so happily married."

"And you have forgotten one matter of joy to me," said Emma, "and a very
considerable one--that I made the match myself. I made the match, you
know, four years ago; and to have it take place, and be proved in the
right, when so many people said Mr. Weston would never marry again, may
comfort me for any thing."

Mr. Knightley shook his head at her. Her father fondly replied, "Ah!
my dear, I wish you would not make matches and foretell things, for
whatever you say always comes to pass. Pray do not make any more
matches."

"I promise you to make none for myself, papa; but I must, indeed, for
other people. It is the greatest amusement in the world! And after such
success, you know!--Every body said that Mr. Weston would never marry
again. Oh dear, no! Mr. Weston, who had been a widower so long, and who
seemed so perfectly comfortable without a wife, so constantly occupied
either in his business in town or among his friends here, always
acceptable wherever he went, always cheerful--Mr. Weston need not spend
a single evening in the year alone if he did not like it. Oh no! Mr.
Weston certainly would never marry again. Some people even talked of a
promise to his wife on her deathbed, and others of the son and the
uncle not letting him. All manner of solemn nonsense was talked on the
subject, but I believed none of it.

"Ever since the day--about four years ago--that Miss Taylor and I met
with him in Broadway Lane, when, because it began to drizzle, he darted
away with so much gallantry, and borrowed two umbrellas for us from
Farmer Mitchell's, I made up my mind on the subject. I planned the match
from that hour; and when such success has blessed me in this instance,
dear papa, you cannot think that I shall leave off match-making."

"I do not understand what you mean by 'success,'" said Mr. Knightley.
"Success supposes endeavour. Your time has been properly and delicately
spent, if you have been endeavouring for the last four years to bring
about this marriage. A worthy employment for a young lady's mind! But
if, which I rather imagine, your making the match, as you call it, means
only your planning it, your saying to yourself one idle day, 'I think it
would be a very good thing for Miss Taylor if Mr. Weston were to marry
her,' and saying it again to yourself every now and then afterwards, why
do you talk of success? Where is your merit? What are you proud of? You
made a lucky guess; and _that_ is all that can be said."

"And have you never known the pleasure and triumph of a lucky guess?--I
pity you.--I thought you cleverer--for, depend upon it a lucky guess is
never merely luck. There is always some talent in it. And as to my
poor word 'success,' which you quarrel with, I do not know that I am so
entirely without any claim to it. You have drawn two pretty pictures;
but I think there may be a third--a something between the do-nothing and
the do-all. If I had not promoted Mr. Weston's visits here, and given
many little encouragements, and smoothed many little matters, it might
not have come to any thing after all. I think you must know Hartfield
enough to comprehend that."

"A straightforward, open-hearted man like Weston, and a rational,
unaffected woman like Miss Taylor, may be safely left to manage their
own concerns. You are more likely to have done harm to yourself, than
good to them, by interference."

"Emma never thinks of herself, if she can do good to others," rejoined
Mr. Woodhouse, understanding but in part. "But, my dear, pray do not
make any more matches; they are silly things, and break up one's family
circle grievously."

"Only one more, papa; only for Mr. Elton. Poor Mr. Elton! You like Mr.
Elton, papa,--I must look about for a wife for him. There is nobody in
Highbury who deserves him--and he has been here a whole year, and has
fitted up his house so comfortably, that it would be a shame to have him
single any longer--and I thought when he was joining their hands to-day,
he looked so very much as if he would like to have the same kind office
done for him! I think very well of Mr. Elton, and this is the only way I
have of doing him a service."

"Mr. Elton is a very pretty young man, to be sure, and a very good young
man, and I have a great regard for him. But if you want to shew him any
attention, my dear, ask him to come and dine with us some day. That will
be a much better thing. I dare say Mr. Knightley will be so kind as to
meet him."

"With a great deal of pleasure, sir, at any time," said Mr. Knightley,
laughing, "and I agree with you entirely, that it will be a much better
thing. Invite him to dinner, Emma, and help him to the best of the fish
and the chicken, but leave him to chuse his own wife. Depend upon it, a
man of six or seven-and-twenty can take care of himself."
"""

string = testText
string = string.replace /\n/, ' '
tokens = []
count = 0

matcher = /\w+/g
while match = matcher.exec(string)
  tokens.push match[0]

testTokens = (tokens, callback) ->
  lookup = (token, done) ->
    wordnet.lookup token, (result) -> done()
  async.each tokens, lookup, callback

testFunction = (tokens, callback) ->
  itemFn = (item, done) ->
    count = count + 1
    testTokens tokens.slice(), done
  async.each [1..1000], itemFn, () ->
    callback()

time = (fn) ->
  startTime = microtime.now()
  end = () ->
    endTime = microtime.now()
    elapsed = endTime - startTime
    console.log "It took " + elapsed + " microseconds to process #{tokens.length} tokens #{count} times"

  fn(end)

time (callback) ->
  testFunction tokens, callback
